/* 
    v.1.0
    ,   -     ( 8192,    )
     -  ,         .
        ,   .   ,     
     ,    .  :
    realList L = realList.Create(23)
    L.AddTail(42)
    L = L.AddHead(16)  ListAddHead(L,15)
    
       cJass v1.4  . 
    
       XGM. NCrashed 2009
*/
library ListLib {

#include "cj_types_priv.j"

define {
        ListAddHead(list,m) = list = list.AddHead(m) //       
        ListDelHead(list) = list = list.DelHead()
        
        DefineOfList(type) = { //     
            
            static type##List Create(type m) { //    1  k
                type##List L = type##List.create()
                L.k = m
                return L
            }
            
            type##List AddHead(type m) { //    ,    !! list = list.AddHead(m)
                type##List L = type##List.Create(m)
                L.next = this
                return L
            }
    
            void AddTail(type m) { //    
                type##List L = type##List.Create(m)
                while ( this.next != null) {this = this.next}
                this.next = L
            }
    
            type Head() { //    
                return this.k
            }
        
            type Last() { //     
                while ( this.next != null) {this = this.next}
                return this.k
            }
    
            type##List Begin() { //  ,       
                if this.next == 0 {return 0} 
                type##List h = type##List.Create(this.k)
                this = this.next
                type##List Result = h
                while (this.next != null) {
                    type##List L = type##List.Create(this.k)
                    h.next = L
                    h = L
                    this = this.next
                }
                return Result
            }
    
            type##List Tail() { //  ,       
                if this.next == 0 {return 0}
                type##List h = type##List.Create(this.next.k)
                this = this.next.next
                type##List Result = h
                while (this != null) {
                    type##List L = type##List.Create(this.k)
                    h.next = L
                    h = L
                    this = this.next
                }
                return Result 
            }
    
            type##List Copy() { //  ,       
                type##List h = type##List.Create(this.k)
                this = this.next
                type##List Result = h
                while (this != null) {
                    type##List L = type##List.Create(this.k)
                    h.next = L
                    h = L
                    this = this.next
                }
                return Result 
            }
        
            int Length() { //   
                int Result = 0
                while (this != null) { this = this.next; Result++ }
                return Result
            }
        
            bool Member(type m) { //  ,   m   
                while (this != null) {if this.k == m {return true};this=this.next}
                return false
            }
            
            bool DelElement(type m) { //    m,   
                if this.Head() == m {return false}
                while (this.next != 0) {
                    if this.next.k == m {
                        type##List h = this.next
                        this.next = this.next.next
                        h.destroy()
                        return true
                    }
                    this=this.next
                }
                return false
            }
            
            type##List DelHead() { //  
                type##List L = this.next
                if this != 0 {this.destroy()}
                return L
            }
            
            void DelTail() { //   
                while ( this.next.next != null) {this = this.next}
                if this != null {this.next.destroy();this.next = 0}
            }
            
            void Destroy() { // 
                type##List L
                while (this != null) {
                        L = this; this = this.next
                        L.next = 0
                        #if type == int
                            L.k = 0
                        #elseif type == real 
                            L.k = 0.
                        #else
                            L.k = null
                        #endif
                        L.destroy()
                }
            }        
        }
}

//       type
//struct typeList {
//    type k = 0
//    typeList next = 0
//
//    DefineOfList(type)
//
//      
//}

//    
struct integerList {
    int k = 0 //  
    integerList next = 0 //    

    DefineOfList(int) //  ,    
    
    #if DEBUG //   ,  ,    JassHelper->Debug Mode
        void DBPrint() {
            ClearTextMessages()
            while (this != null) {
                BJDebugMsg(I2S(this.k))
                this = this.next
            }
        }
    #endif
}

struct realList {
    real k = 0.
    realList next = 0

    DefineOfList(real)
    
    #if DEBUG 
        void DBPrint() {
            ClearTextMessages()
            while (this != null) {
                BJDebugMsg(R2S(this.k))
                this = this.next
            }
        }
    #endif
}

struct unitList {
    unit k = null
    unitList next = 0
    
    DefineOfList(unit)
    
    #if DEBUG 
        void DBPrint() {
            ClearTextMessages()
            while (this != null) {
                BJDebugMsg(GetUnitName(this.k)+" ("+R2S(GetUnitX(this.k))+","+R2S(GetUnitY(this.k))+")")
                this = this.next
            }
        }
    #endif
}

struct destructableList {
    destructable k = null
    destructableList next = 0
    
    DefineOfList(destructable)
}

struct timerList {
    timer k = null
    timerList next = 0
    
    DefineOfList(timer)
}


}