using System;
using System.Collections.Generic;
using System.Text;
using Shared;
using System.Windows.Forms;

namespace pluginTest
{
    public class MyCoolPlugin : IWePlugin
    {
        private Version version;
        private String author;
        private IWeNotify notifier;
        public String PluginAuthor { get { return author; } }
        public Version PluginVersion { get { return version; } }
        public IWeNotify Notifier { get { return notifier; } }

        public MyCoolPlugin()
        {
            //set some properties
            author = "Risc";
            version = new Version("1.0");
        }

        public IWeNotify RegisterNotify()
        {
            notifier = new PluginNotifier();
            notifier.OnRegisterPlugin += new delegateRegisterPlugin(notifier_OnRegisterPlugin);
            notifier.WindowCreated += new delegateWindowCreated(notifier_WindowCreated);
            //the return-type is reserved for further use.
            return notifier;
        }

        void notifier_WindowCreated(string className, string windowText, IntPtr hWnd)
        {
            if(windowText == "About Warcraft III World Editor UMS")
                MessageBox.Show("Cool");
        }

        void notifier_OnRegisterPlugin()
        {
            MessageBox.Show("Hello WorldEdit!");
        }
    }
}
